# $autorun

# Get Qt key names with
# https://doc.qt.io/qt-5/qt.html#Key-enum


# I have some fear that this could have stability problems
# Mathias talks about setting an attribute :
#   wdg.setAttribute(Qt::WA_DeleteOnClose)
   
# https://www.klayout.de/forum/discussion/611/question-about-using-qt-to-generate-an-additional-ui

# Matthias has is own Qt application in here in ruby, and someone has a python translation
# I found that in the python translation, you may need to modify
#   if wdg is not None and not wdg.destroyed():
#        to
#   if wdg is not None and not wdg.destroyed_:



print("Hello World from pbasic5.py")

pya.gregSelectList = []

pya.greg_egrid_str = "NULL"

pya.greg_egrid_x = 0.1
pya.greg_egrid_y = 0.1

pya.greg_xloc = 0.0
pya.greg_yloc = 0.0

pya.greg_xval = 0.0
pya.greg_yval = 0.0

pya.greg_px = 0.0
pya.greg_py = 0.0

pya.greg_cursor_color = 0x0000FF
pya.greg_basemk_color = 0x00FF00

def gg(x):
  app = pya.Application.instance()
  app.set_config("grid-micron", str(x))
  print("Hi ShanGrid")

ss = 0

def processClick():
  global ss
  
  pya.greg_label.setText("I was clicked " + str(ss) + " times!")
  ss = ss + 1
  
def GregCreateRefWin():

  pya.greg_RefWin = pya.QDialog(pya.Application.instance().main_window())
  pya.greg_RefWin.windowTitle = "Pbasic4"
  
  pya.greg_layout = pya.QVBoxLayout(pya.greg_RefWin)
  pya.greg_RefWin.setLayout(pya.greg_layout)
    
  pya.greg_label = pya.QLabel(pya.greg_RefWin)
  pya.greg_layout.addWidget(pya.greg_label)
  pya.greg_label.setText("(No Data Yet)")

  pya.greg_button = pya.QPushButton(pya.greg_RefWin)
  pya.greg_layout.addWidget(pya.greg_button)
  pya.greg_button.text = "Click Me"
  pya.greg_button.clicked = processClick
  
  pya.greg_RefWin.resize(400,100)
  pya.greg_RefWin.move(600,300)

  # note show lets it run concurently, whild exec does not
  pya.greg_RefWin.show()


GregCreateRefWin()


class GregRefPntPluginFactory(pya.PluginFactory):

  def __init__(self):
    super(GregRefPntPluginFactory, self).__init__()
    # this tool is only available through menu:
    self.has_tool_entry = False
    self.add_menu_entry("enable", "enable", "tools_menu.end", "GregRefPnt")
    self.register(-1000, "gregref", "GregRefPnt")

  def create_plugin(self, manager, root, view):
    return GregRefPntPlugin()

  # Keeps the singleton instance
  instance = None
  

# Create and store the singleton instance
GregRefPntPluginFactory.instance = GregRefPntPluginFactory()


class GregRefPntPlugin(pya.Plugin):

  def __init__(self):
    super(GregRefPntPlugin, self).__init__()
    self.xstro = '0.000'
    self.ystro = '0.000'
    self.shan_enable = False
    self.shan_cursor_on = False

    pass


  def menu_activated(self, symbol):
    if symbol == "enable":
      self.grab_mouse()
      self.shan_enable = True
      pya.MainWindow.instance().message("Right click on point to set the origin", 1000)

      self.shan_cursor_on = True
      self.shan_lv = pya.Application.instance().main_window().current_view().current()

      self.shan_marker = pya.Marker.new(self.shan_lv)
      self.shan_marker.color = pya.greg_cursor_color
      self.shan_marker.set(pya.DBox.new())
      
      self.shan_basemk = pya.Marker.new(self.shan_lv)
      self.shan_basemk.color = pya.greg_basemk_color
      self.shan_basemk.set(pya.DBox.new())


  def mouse_moved_event(self, p, buttons, prio):
    pya.greg_px = p.x
    pya.greg_py = p.y
  
    # This is where everything happens
    if prio:
      estr = pya.Application.instance().get_config("edit-grid")
 
      if (estr == 'global'):
        estr = pya.Application.instance().get_config("grid-micron")
        
      if (estr != pya.greg_egrid_str):
        print("haha %s" % estr)
        pya.greg_egrid_x = float(estr)
        pya.greg_egrid_y = float(estr)
        pya.greg_egrid_str = estr

      pya.greg_xval = round(p.x / pya.greg_egrid_x) * pya.greg_egrid_x
      pya.greg_yval = round(p.y / pya.greg_egrid_y) * pya.greg_egrid_y

      pya.greg_uval = pya.greg_xval - pya.greg_xloc
      pya.greg_vval = pya.greg_yval - pya.greg_yloc

        
      xstr  = '%0.3f' % pya.greg_uval 
      ystr  = '%0.3f' % pya.greg_vval


      if ((xstr != self.xstro) or (ystr != self.ystro)):
        pya.greg_label.setText("GregRef : x=%0.3f y=%0.3f   dx=%s dy=%s" % (pya.greg_xval, pya.greg_yval, xstr, ystr))
        self.xstro = xstr
        self.ystro = ystr

        if (self.shan_cursor_on):
          xm0 = pya.greg_xval
          ym0 = pya.greg_yval
          xm1 = xm0 - pya.greg_egrid_x / 2.0
          ym1 = ym0 - pya.greg_egrid_y / 2.0
          xm2 = xm0 + pya.greg_egrid_x / 2.0
          ym2 = ym0 + pya.greg_egrid_y / 2.0
          self.shan_marker.set(pya.DBox.new(xm1, ym1, xm2, ym2))

          xm0 = pya.greg_xloc
          ym0 = pya.greg_yloc
          xm1 = xm0 - pya.greg_egrid_x / 2.0
          ym1 = ym0 - pya.greg_egrid_y / 2.0
          xm2 = xm0 + pya.greg_egrid_x / 2.0
          ym2 = ym0 + pya.greg_egrid_y / 2.0
          self.shan_basemk.set(pya.DBox.new(xm1, ym1, xm2, ym2))
          # marker.set(pya.DBox.new(xm1, ym0, xm2, ym0))
          # marker.set(pya.DBox.new(xm0, ym1, xm0, ym2))

          
      if (not self.shan_enable):
        self.ungrab_mouse()
        pya.greg_label.setText("Done")
        return True
        
    return False


print("Hi GregPntZ")


